local mod = ...



-- Building Function: Gather Berries -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_COTTAGE_BERRIES",
    Name = "BUILDING_FUNCTION_COTTAGE_BERRIES_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "GATHERER", 
        Behavior = "BEHAVIOR_GATHER"
    },
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
		{ Resource = "BERRIES", Quantity = 1 },
	},
    ResourceProduced = {
		{ Resource = "BERRIES", Quantity = 1 },
	}
})



-- Building Function: Gather Wood -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_COTTAGE_WOOD",
    Name = "BUILDING_FUNCTION_COTTAGE_WOOD_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "WOOD_CUTTER", 
        Behavior = "BEHAVIOR_GATHER"
    },
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
		{ Resource = "WOOD", Quantity = 1 },
	},
    ResourceProduced = {
		{ Resource = "WOOD", Quantity = 1 },
	}
})



-- Building Function: Grow Beans -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_FARM",
    Id = "BUILDING_FUNCTION_COTTAGE_BEAN",
    Name = "BUILDING_FUNCTION_COTTAGE_BEAN_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "VEGETABLEFARMER2_JOB", 
        Behavior = "BEHAVIOR_FARMER"
    },
    ResourceListNeeded = {
        { Resource = "RESOURCE_VEGETABLE", Quantity = 1 }, 
    },
    ResourceProduced = {
        { Resource = "RESOURCE_VEGETABLE", Quantity = 1 },
    },

    SowingDurationPerc = {0, 6},
    GrowDuration = {6, 10},
    GrowWaitDuration = {10, 12},
    HarvestDuration = {12, 18},
    RestDuration = {18, 21},

    QuantityToHarvestPerStep = 1,
    HarvestStepsCount = 10,
    QuantityToPlantPerStep = 1,
    PlantingStepsCount = 1,
    ResourceValuePerGather = 0.15,
    
    CropFieldConfig = "FARM_FIELD_CONFIG_VEGETABLE_FARM_BEAN",
    GrowingSetup = "AGENT_WORKSTATION_SETUP_VEGETABLE_FARM_GROWING",
    SowingSetup = "AGENT_WORKSTATION_SETUP_VEGETABLE_FARM_SOWING",
    HarvestSetup = "AGENT_WORKSTATION_SETUP_VEGETABLE_FARM_HARVEST"
})



-- Building Function: Grow Cabbages -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_FARM",
    Id = "BUILDING_FUNCTION_COTTAGE_CABBAGE",
    Name = "BUILDING_FUNCTION_COTTAGE_CABBAGE_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "VEGETABLEFARMER2_JOB", 
        Behavior = "BEHAVIOR_FARMER"
    },
    ResourceListNeeded = {
        { Resource = "RESOURCE_VEGETABLE", Quantity = 1 }, 
    },
    ResourceProduced = {
        { Resource = "RESOURCE_VEGETABLE", Quantity = 1 },
    },

    SowingDurationPerc = {0, 6},
    GrowDuration = {6, 10},
    GrowWaitDuration = {10, 12},
    HarvestDuration = {12, 18},
    RestDuration = {18, 21},

    QuantityToHarvestPerStep = 1,
    HarvestStepsCount = 10,
    QuantityToPlantPerStep = 1,
    PlantingStepsCount = 1,
    ResourceValuePerGather = 0.15,
    
    CropFieldConfig = "FARM_FIELD_CONFIG_VEGETABLE_FARM_CABBAGE",
    GrowingSetup = "AGENT_WORKSTATION_SETUP_VEGETABLE_FARM_GROWING",
    SowingSetup = "AGENT_WORKSTATION_SETUP_VEGETABLE_FARM_SOWING",
    HarvestSetup = "AGENT_WORKSTATION_SETUP_VEGETABLE_FARM_HARVEST"
})



-- Building Function: Bake Bread -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_COTTAGE_BREAD",
    Name = "BUILDING_FUNCTION_COTTAGE_BREAD_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "BAKER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "FLOUR", Quantity = 10 },
		{ Resource = "WATER", Quantity = 10 },
	},
    ResourceListNeeded = {
		{ Resource = "FLOUR", Quantity = 2 },
		{ Resource = "WATER", Quantity = 2 },
	},
    ResourceProduced = {
		{ Resource = "BREAD", Quantity = 1 }
	}
})



-- Building Function: Make Cheese -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_COTTAGE_CHEESE",
    Name = "BUILDING_FUNCTION_COTTAGE_CHEESE_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "CHEESE_MAKER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "MILK", Quantity = 10 },
	},
    ResourceListNeeded = {
		{ Resource = "MILK", Quantity = 2 },
	},
    ResourceProduced = {
		{ Resource = "CHEESE", Quantity = 1 },
	}
})



-- Building Function: Weave Cloth -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_COTTAGE_CLOTH",
    Name = "BUILDING_FUNCTION_COTTAGE_CLOTH_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "WEAVER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "WOOL", Quantity = 10 },
	},
    ResourceListNeeded = {
		{ Resource = "WOOL", Quantity = 2 },
	},
    ResourceProduced = {
		{ Resource = "WOOLEN_CLOTH", Quantity = 1 },
	}
})



-- Building Function: Sew Clothes -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_COTTAGE_CLOTHES",
    Name = "BUILDING_FUNCTION_COTTAGE_CLOTHES_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "TAILOR", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "WOOLEN_CLOTH", Quantity = 10 },
	},
    ResourceListNeeded = {
		{ Resource = "WOOLEN_CLOTH", Quantity = 2 },
	},
    ResourceProduced = {
		{ Resource = "CLOTHES", Quantity = 1 },
	}
})



-- Building Function: Cottage Industry ASSIGNABLE -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_COTTAGE",
    AuthorizedFunctionList = "FUNCTION_LIST_COTTAGE"
})

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "FUNCTION_LIST_COTTAGE",
    AssetFunctionList = {
        "BUILDING_FUNCTION_COTTAGE_BERRIES",
        "BUILDING_FUNCTION_COTTAGE_WOOD",
        "BUILDING_FUNCTION_FORESTER",
        "BUILDING_FUNCTION_COTTAGE_BEAN",
        "BUILDING_FUNCTION_COTTAGE_CABBAGE",
        "BUILDING_FUNCTION_COTTAGE_BREAD",
        "BUILDING_FUNCTION_COTTAGE_CHEESE",
        "BUILDING_FUNCTION_COTTAGE_CLOTH",
        "BUILDING_FUNCTION_COTTAGE_CLOTHES",
        "BUILDING_FUNCTION_HUNTERS_HUT",
    }
})



-- Give names to unnamed functions
mod:override({
    Id = "BUILDING_FUNCTION_FORESTER",
    Name = "BUILDING_FUNCTION_FORESTER_NAME"
})

mod:override({
    Id = "BUILDING_FUNCTION_HUNTERS_HUT",
    Name = "BUILDING_FUNCTION_HUNTERS_HUT_NAME"
})



-- Allow large serf houses to have a workplace function -------------------------------------------------------------------------------------
mod:override({
    Id = "BUILDING_PART_HOUSING_SERF_DENSITY_2",
    Name = "BUILDING_PART_HOUSING_SERF_DENSITY_2_NAME",
    AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_COTTAGE"
})

